/* --------------------------------------------------------------------	*/
/* This is the subroutine which is called from the main prog 'CDM_Impo'	*/
/* --------------------------------------------------------------------	*/
/* 									*/
/* This subroutine is called from main for each line in the list	*/
/* of source-files (mp3-files) which are to be imported			*/
/* if you select 'Extract Track Data...' 'by External Module'		*/
/* in the 'Settings'-Dialog.						*/
/* 									*/
/* --------------------------------------------------------------------	*/


SourceFile  = arg(1);	/* complete file specification (path)				*/
BaseDir     = arg(2);	/* part of SourceFile, which is not used for data derivation	*/
Delimiter   = arg(3);	/* which separated Artist - Volume - Title			*/
Opt_UsePath = arg(4);	/* 1=use all dirname, 0=use only filename			*/

ID_Error  = " ";		/* return-data that start with this character are errormessages	*/
ID_TrData = "01"x;		/* on return:
				artist, volume(album), title are separated by this character	*/

/* Parameter-Checking:				*/
if substr(SourceFile, 2,2) <> ":\" then
   SIGNAL Error_Exit1;

if BaseDir = "" then do
   BaseDir = "x:\";
end;
else;do
   if substr(BaseDir, 2,2) <> ":\" then
      SIGNAL Error_Exit2;
   if right(BaseDir,1) <> "\" then BaseDir = BaseDir||"\";	/* must always end with an '\'	*/
end;




Data = ExtractData( Title, Path );

return 	Data;


------------------------------------------------

Error_Exit1:
   return ID_Error||"invalid SourceFile: no drive-letter";

Error_Exit2:
   return ID_Error||"invalid BaseDir: no drive-letter";

Error_Exit3:
   return ID_Error||"invalid SourceFile: no file-extension";

Error_Exit4:
   return ID_Error||"'UsePath' specified but no path provided";

------------------------------------------------

/* Subroutines:						*/


ExtractData: Procedure Expose 	,
		ID_TrData	,
		Delimiter;
Title  = arg(1);
Path   = arg(2);	/* [ path | "" ]		*/

TrkNum = 0;		/* default			*/

/* Evaluate Track-Data:    */

return 	Artist||ID_TrData||	,
     	Volume||ID_TrData||	,
     	Title||ID_TrData||	,
	TrkNum;
